unit Tags;
    interface
        uses Flags;
        type
            A_tag = (
                Tag_Bold,Tag_Italic,Tag_Ul,Tag_Strong,Tag_EM,Tag_PL,Tag_TT,
                Tag_0,Tag_1,Tag_2,Tag_3,Tag_4,Tag_5,Tag_6,Tag_7,Tag_8,Tag_9,
                Tag_red,Tag_green,Tag_blue,Tag_cyan,Tag_magenta,Tag_yellow,Tag_black,Tag_white,
                Tag_fail
                );
            A_bag_of_tags = string;
        const
            First_tag = Tag_Bold;
            Last_tag  = Tag_fail;
            Text_of_tag : array [A_tag] of string [2] = (
                'B','I','U','S','EM','PL','TT',
                '0','1','2','3','4','5','6','7','8','9',
                'r','g','b','c','m','y','k','w',''
                );
        var
            Tag_starting : array [char] of A_tag;
        procedure Mod_flags(var D : A_decoration; Ch : char);
        function Can_get_between(D1,D2 : A_decoration; var Steps : A_bag_of_tags) : boolean;
        procedure Empty_bag(var B : A_bag_of_tags);
        function Bag_contains(T : A_tag; B : A_bag_of_tags) : boolean;
        procedure Accumulate_tag(T : A_tag; var B : A_bag_of_tags);
        procedure Accumulate_anti_tag(T : A_tag; var B : A_bag_of_tags);
        procedure Remove_from_bag(T : A_tag; var B : A_bag_of_tags);
        function Item_from_bag(var B : A_bag_of_tags; I : integer; var T : A_tag; var Anti : boolean) : boolean;
        function Pull_from_bag(var B : A_bag_of_tags; var T : A_tag; var Anti : boolean) : boolean;
        function Cost_of_bag(B : A_bag_of_tags) : integer;
        function Reverse_bag(B : A_bag_of_tags) : A_bag_of_tags;
    implementation
        procedure Mod_flags(var D : A_decoration; Ch : char);
            begin
                with D do begin
                    case Ch of
                      'B': F := F + [B_ ];
                      'E': if EM_ in F then F := F - [EM_]
                            else            F := F + [EM_];
                      'I': F := F + [I_];
                      'P': F := F - [U_1,U_2,S_,EM_,I_,B_,TT_];
                      'S': begin
                        F := F + [S_];
                        M := M + [EM_];
                        end;
                      'T': F := F + [TT_];
                      'U': Inc_U(F);
                      '0': F := (F - Size_mask) + Size_0;
                      '1': F := (F - Size_mask) + Size_1;
                      '2': F := (F - Size_mask) + Size_2;
                      '3': F := (F - Size_mask) + Size_3;
                      '4': F := (F - Size_mask) + Size_4;
                      '5': F := (F - Size_mask) + Size_5;
                      '6': F := (F - Size_mask) + Size_6;
                      '7': F := (F - Size_mask) + Size_7;
                      '8': F := (F - Size_mask) + Size_8;
                      '9': F := (F - Size_mask) + Size_9;
                      'r': F := (F - Color_mask) + Red;
                      'g': F := (F - Color_mask) + Green;
                      'b': F := (F - Color_mask) + Blue;
                      'c': F := (F - Color_mask) + Cyan;
                      'y': F := (F - Color_mask) + Yellow;
                      'm': F := (F - Color_mask) + Magenta;
                      'k': F := (F - Color_mask) + Black;
                      'w': F := (F - Color_mask) + White;
                      end;
                    F := F - M;
                    //write(ErrOutput,'{',Ch,'-->',Cl(F),'}');
                    end;
                end;
        function Tag_for_size(F : A_flag_set) : A_tag;
            begin
                case Sz(F) of
                  0:   Result := Tag_0;
                  1:   Result := Tag_1;
                  2:   Result := Tag_2;
                  3:   Result := Tag_3;
                  4:   Result := Tag_4;
                  5:   Result := Tag_5;
                  6:   Result := Tag_6;
                  7:   Result := Tag_7;
                  8:   Result := Tag_8;
                  9:   Result := Tag_9;
                  else Result := Tag_fail;
                  end;
                end;
        function Tag_for_color(F : A_flag_set) : A_tag;
            begin
                case Cl(F) of
                  0:   Result := Tag_white;
                  1:   Result := Tag_black;
                  2:   Result := Tag_yellow;
                  3:   Result := Tag_magenta;
                  4:   Result := Tag_cyan;
                  5:   Result := Tag_red;
                  6:   Result := Tag_green;
                  7:   Result := Tag_blue;
                  else Result := Tag_fail;
                  end;
                end;
        function Can_get_between(D1,D2 : A_decoration; var Steps : A_bag_of_tags) : boolean;
            procedure Flag(V : A_flag; T : A_tag);
                begin
                    if (V in D1.F) <> (V in D2.F) then
                        if V in D2.F then
                            Accumulate_tag(T,Steps)
                          else
                            Accumulate_tag(Tag_fail,Steps);
                    end;
            var
                I : integer;
            begin
                Empty_bag(Steps);
                if (D1.F * Size_mask) <> (D2.F * Size_mask) then
                    Accumulate_tag(Tag_for_size(D2.F),Steps);
                if (D1.F * Color_mask) <> (D2.F * Color_mask) then
                    Accumulate_tag(Tag_for_color(D2.F),Steps);
                Flag(B_,Tag_bold);
                Flag(I_,Tag_italic);
                Flag(TT_,Tag_TT);
                Flag(S_,Tag_Strong);
                if not (S_ in D2.F) then
                    if (EM_ in D1.F) <> (EM_ in D2.F) then
                        Accumulate_tag(Tag_EM,Steps);
                if ULs(D1.F) > ULs(D2.F) then
                    Accumulate_tag(Tag_fail,Steps)
                  else
                    for I := ULs(D1.F)+1 to ULs(D2.F) do
                        Accumulate_tag(Tag_Ul,Steps);
                Result := not Bag_contains(Tag_fail,Steps);
                end;
        procedure Empty_bag(var B : A_bag_of_tags);
            begin
                B := '';
                end;
(*
        function Bag_contains(T : A_tag; B : A_bag_of_tags) : boolean;
            begin
                Result := pos(' '+Text_of_tag[T][1],B) <> 0;
                end;
        procedure Accumulate_tag(T : A_tag; var B : A_bag_of_tags);
            begin
                B := B+' '+Text_of_tag[T][1];
                end;
        procedure Accumulate_anti_tag(T : A_tag; var B : A_bag_of_tags);
            begin
                if copy(B,length(B)-1,2) = ' '+Text_of_tag[T][1] then
                    delete(B,length(B)-1,2)
                  else
                    B := B+'/'+Text_of_tag[T][1];
                end;
        procedure Remove_from_bag(T : A_tag; var B : A_bag_of_tags);
            var
                I : integer;
            begin
                I := pos(' '+Text_of_tag[T][1],B);
                if I <> 0 then delete(B,I,2);
                end;
        function Pull_from_bag(var B : A_bag_of_tags; var T : A_tag; var Anti : boolean) : boolean;
            begin
                if length(B) = 0 then
                    Result := false
                  else begin
                    Anti := B[1] = '/';
                    T := Tag_starting[B[2]];
                    Result := T <> Tag_fail;
                    delete(B,1,2);
                    end;
                end;
        function Item_from_bag(var B : A_bag_of_tags; I : integer; var T : A_tag; var Anti : boolean) : boolean;
            begin
                if I > length(B) then
                    Result := false
                  else begin
                    Anti := B[2*I-1] = '/';
                    T := Tag_starting[B[2*I]];
                    Result := T <> Tag_fail;
                    end;
                end;
        function Cost_of_bag(B : A_bag_of_tags) : integer;
            var
                I : integer;
            begin
                Result := 0;
                for I := 1 to length(B) div 2 do
                    if B[I*2-1] = ' ' then
                        Result := Result + length(Text_of_tag[Tag_starting[B[2*I]]]);
                end;
        function Reverse_bag(B : A_bag_of_tags) : A_bag_of_tags;
            var
                I : integer;
                T : A_tag;
            begin
                Empty_bag(Result);
                for I := length(B) div 2 downto 1 do begin
                    T := Tag_starting[B[I*2]];
                    if B[I*2-1] = ' ' then
                        Accumulate_anti_tag(T,Result)
                      else
                        Accumulate_tag(T,Result)
                    end;
                end;
*)
        function Bag_contains(T : A_tag; B : A_bag_of_tags) : boolean;
            begin
                //write(ErrOutput,'(BC');
                Result := pos(''+Text_of_tag[T][1],B) <> 0;
                //write(ErrOutput,')');
                end;
        procedure Accumulate_tag(T : A_tag; var B : A_bag_of_tags);
            begin
                //write(ErrOutput,'(AT');
                B := B+Text_of_tag[T][1];
                //write(ErrOutput,')');
                end;
        procedure Accumulate_anti_tag(T : A_tag; var B : A_bag_of_tags);
            var
                X : integer;
            begin
                //write(ErrOutput,'(AAT');
                if (length(B) > 0) and (B[length(B)] = Text_of_tag[T][1]) then
                    delete(B,length(B),1)
                  else begin
                    X := ord(Text_of_tag[T][1]);
                    B := B+char(X or 128);
                    end;
                //write(ErrOutput,')');
                end;
        procedure Remove_from_bag(T : A_tag; var B : A_bag_of_tags);
            var
                I : integer;
            begin
                //write(ErrOutput,'(RfB');
                I := pos(''+Text_of_tag[T][1],B);
                if I <> 0 then delete(B,I,1);
                //write(ErrOutput,')');
                end;
        function Pull_from_bag(var B : A_bag_of_tags; var T : A_tag; var Anti : boolean) : boolean;
            var
                X : integer;
            begin
                //write(ErrOutput,'(PfB');
                if length(B) = 0 then
                    Result := false
                  else begin
                    Anti := B[1] > #128;
                    X := ord(B[1]);
                    T := Tag_starting[char(X and 127)];
                    Result := T <> Tag_fail;
                    delete(B,1,1);
                    end;
                //write(ErrOutput,')');
                end;
        function Item_from_bag(var B : A_bag_of_tags; I : integer; var T : A_tag; var Anti : boolean) : boolean;
            var
                X : integer;
            begin
                //write(ErrOutput,'(IfB');
                if I > length(B) then
                    Result := false
                  else begin
                    Anti := B[I] > #128;
                    X := ord(B[I]);
                    T := Tag_starting[char(X and 127)];
                    Result := T <> Tag_fail;
                    end;
                //write(ErrOutput,')');
                end;
        function Cost_of_bag(B : A_bag_of_tags) : integer;
            var
                I : integer;
            begin
                //write(ErrOutput,'(CoB');
                Result := 0;
                for I := 1 to length(B) do
                    Result := Result + length(Text_of_tag[Tag_starting[B[I]]]);
                //write(ErrOutput,')');
                end;
        function Reverse_bag(B : A_bag_of_tags) : A_bag_of_tags;
            var
                I,X : integer;
            begin
                //write(ErrOutput,'(RB');
                Result := '';
                Setlength(Result,length(B));
                for I := length(B) downto 1 do begin
                    X := ord(B[I]);
                    Result[length(B)-I+1] := char(X xor 128);
                    end;
                    //Result := Result + char(ord(B[I]) xor 128);
                //write(ErrOutput,')');
                end;
    var
        Ch : char;
        T  : A_tag;
    begin
        for Ch := #0 to #255 do
            Tag_starting[Ch] := Tag_fail;
        for T := First_tag to Last_tag do
            Tag_starting[Text_of_tag[T][1]] := T;
        end.
    
