unit flags;
    interface
        type
            A_flag = (B_,EM_,I_,S_,TT_,U_1,U_2,S_1,S_2,S_4,S_8,C_1,C_2,C_3,C_X,Outer_);
            A_flag_set = set of A_flag;
            A_decoration = record
                F,M : A_flag_set;
                end;
        const
            Color_mask = [C_1,C_2,C_3,C_X];
            Unknown_color= Color_mask;
            White      = [           ];
            Black      = [C_1        ];
            Yellow     = [    C_2    ];
            Magenta    = [C_1,C_2    ];
            Cyan       = [        C_3];
            Red        = [C_1,    C_3];
            Green      = [    C_2,C_3];
            Blue       = [C_1,C_2,C_3];
            Size_mask  = [S_1,S_2,S_4,S_8];
            Size_0     = [               ];
            Size_1     = [S_1            ];
            Size_2     = [    S_2        ];
            Size_3     = [S_1,S_2        ];
            Size_4     = [        S_4    ];
            Size_5     = [S_1,    S_4    ];
            Size_6     = [    S_2,S_4    ];
            Size_7     = [S_1,S_2,S_4    ];
            Size_8     = [            S_8];
            Size_9     = [S_1,        S_8];
            Unknown_size = Size_mask;
        function ULs(F : A_flag_set) : integer;
        function Sz(F : A_flag_set) : integer;
        function Cl(F : A_flag_set) : integer;
        procedure Inc_U(var F : A_flag_set);
        function Merge_flags(var F1,M1 : A_flag_set; F2,M2 : A_flag_set) : boolean;
    implementation
        function ULs(F : A_flag_set) : integer;
            begin
                Result := 0;
                if U_1 in F then inc(Result,1);
                if U_2 in F then inc(Result,2);
                end;
        function Sz(F : A_flag_set) : integer;
            begin
                Result := 0;
                if S_1 in F then inc(Result,1);
                if S_2 in F then inc(Result,2);
                if S_4 in F then inc(Result,4);
                if S_8 in F then inc(Result,8);
                end;
        function Cl(F : A_flag_set) : integer;
            begin
                Result := 0;
                if C_1 in F then inc(Result,1);
                if C_2 in F then inc(Result,2);
                if C_3 in F then inc(Result,4);
                if C_X in F then inc(Result,8);
                //write('(',Result,')');
                end;
        procedure Inc_U(var F : A_flag_set);
            begin
                case ULs(F) of
                  0: F :=  F + [U_1];
                  1: F := (F + [U_2]) - [U_1];
                  2: F :=  F + [U_1];
                  end;
                end;
        function Merge_flags(var F1,M1 : A_flag_set; F2,M2 : A_flag_set) : boolean;
            begin
                if F2 - (M1 + M2) = F1 - (M1 + M2) then begin
                    Result := true;
                    F1 := (F1 - M1) + (F2 - M2);
                    M1 := M1 * M2;
                    end
                  else
                    Result := false;
                end;
        end.
        
