{ (c) 2001 By Markus Q. Roberts; }
{   MarkusQ@reality.com          }
{ Released under GPL             }
program V2;
    uses SysUtils,flags,Tags;
    type
        A_tag_block = record
            Tags         : A_bag_of_tags;
            Result_state : A_decoration;
            Cost         : integer;
            end;
        An_option = record
            Prior : integer;
            Steps : array of A_tag_block;
            Cost  : integer;
            end;
    var
        Block : record
            Count  : integer;
            Number : array [0..1500000] of record
                Decoration : A_decoration;
                Body       : string;
                Best       : integer;
                Options    : array of An_option;
                end;
            end;
    type
        A_state = record
            Top   : integer;
            Stack : array [0..600000] of A_decoration;
            Tags  : array [0..600000] of A_tag;
            Prior_was_space : boolean;
            SF    : A_flag_set;
            end;
    var
        State : A_state;
    procedure Clear_state;
        begin
            with State do begin
                Top := 0;
                Stack[0].F := Unknown_size + Unknown_color;
                Stack[0].M := [];
                Prior_was_space := false;
                end;
             end;
    procedure Clear_tag_block(var B : A_tag_block);
        begin
            with B do begin
                Empty_bag(Tags);
                Result_state := State.Stack[State.Top];
                Cost   := 0;
                end;
            end;
    procedure Clear_option(var O : An_option);
        begin
            with O do begin
                Prior := 0;
                Steps := nil;
                Cost  := 0;
                end;
            end;
    function Add_option(I,Prior_option : integer) : integer;
        begin
            with Block.Number[I] do begin
                setlength(Options,1);
                Result := length(Options)-1;
                Clear_option(Options[Result]);
                with Options[Result] do begin
                    Prior := Prior_option;
                    Cost  := Block.Number[I-1].Options[Prior].Cost;
                    end;
                end;
            end;
    procedure Add_step(var O : An_option; T : A_tag_block);
        begin
            setlength(O.Steps,length(O.Steps)+1);
            O.Steps[length(O.Steps)-1] := T;
            O.Cost := O.Cost + T.Cost;
            end;
    procedure Read_and_interpret_source;
        var
            For_next_block : A_tag_block;
        procedure Next_block;
            begin
                if length(Block.Number[Block.Count].Body) <> 0 then begin
                    inc(Block.Count);
                    with Block.Number[Block.Count] do begin
                        Body := '';
                        Best := 0;
                        Options := nil;
                        For_next_block.Cost := Cost_of_bag(For_next_block.Tags);
                        For_next_block.Result_state := State.Stack[State.Top];
                        Add_step(Options[Add_option(Block.Count,0)],For_next_block);
                        Clear_tag_block(For_next_block);
                        end;
                    end;
                Block.Number[Block.Count].Decoration := State.Stack[State.Top];
                end;
        procedure Emit(Ch : char; D : A_decoration);
            begin
                with Block.Number[Block.Count].Decoration do
                    if not Merge_flags(F,M,D.F,D.M) then
                        Next_block;
                with Block.Number[Block.Count] do
                    Body := Body + Ch;
                State.Prior_was_space := Ch = ' ';
                State.SF := D.F - D.M;
                end;
        var
            Ch : char;
            D  : A_decoration;
        begin
            Clear_state;
            Clear_tag_block(For_next_block);
            Block.Count := 0;
            with Block.Number[0] do begin
                Body := '$';
                Best := 0;
                Decoration := State.Stack[0];
                Decoration.F  := Decoration.F + [Outer_];
                Options := nil;
                setlength(Options,1);
                Clear_option(Options[0]);
                Add_step(Options[0],For_next_block);
                end;
            while not eof do begin
                read(Ch);
                if Ch = '<' then begin
                    read(Ch);
                    with State do
                        if Ch = '/' then begin
                            if Top > 0 then dec(Top);
                            read(Ch);
                            Accumulate_anti_tag(Tag_starting[Ch],For_next_block.Tags);
                            end
                          else begin
                            inc(Top);
                            Stack[Top] := Stack[Top-1];
                            Accumulate_tag(Tag_starting[Ch],For_next_block.Tags);
                            Mod_flags(Stack[Top],Ch);
                            end;
                    while not (eof or (Ch = '>')) do read(Ch);
                    end
                  else with State,Stack[Top] do begin
                    D := Stack[Top];
                    if Ch > ' ' then
                        Emit(Ch,D)
                      else begin
                        D.M := D.M + [S_,EM_,I_,B_];
                        if ULs(D.F) = 0 then D.M := D.M + Color_mask;
                        if TT_ in F then
                            Emit(Ch,D)
                          else if not Prior_was_space then
                            Emit(' ',D)
                          else if (D.F - D.M) <> SF then
                            Emit(' ',D);
                        end;
                    end;
                if length(Block.Number[Block.Count].Body) > 1000 then Next_block;
                end;
            end;
        procedure Generate_options;
            procedure Push_tag(Tag : string);
                begin
                    with State do begin
                        inc(Top);
                        Stack[Top] := Stack[Top-1];
                        Tags[Top]  := Tag_starting[Tag[1]];
                        Mod_flags(Stack[Top],Tag[1]);
                        end;
                    end;
            function Pop_tag : A_tag;
                begin
                    with State do
                        if Top > 0 then begin
                            Result := Tags[Top];
                            dec(Top);
                            end
                          else
                            Result := Tag_fail;
                    end;
            procedure Apply_tags(B : A_bag_of_tags);
                var
                    T : A_tag;
                    A : boolean;
                    I : integer;
                begin
                    I := 1;
                    while Item_from_bag(B,I,T,A) do begin
                        if A then
                            Pop_tag
                          else
                            Push_tag(Text_of_tag[T]);
                        inc(I);
                        end;
                    end;
            const
                Max_opt_count = 20;
            var
                I,Best_option,Best_cost,Prior : integer;
                Prep,B   : A_bag_of_tags;
                Opt : record
                    Count  : integer;
                    Number : array [1..Max_opt_count] of A_bag_of_tags;
                    end;
                Blk : A_tag_block;
            procedure Consider(B1,B2 : A_bag_of_tags);
                begin
                    inc(Opt.Count);
                    Opt.Number[Opt.Count] := B1+B2;
                    end;
            procedure Consider_just_adding;
                begin
                    Empty_bag(Prep);
                    if Can_get_between(State.Stack[State.Top],Block.Number[I].Decoration,B) then
                        Consider(Prep,B);
                    end;
            procedure Consider_PL;
                begin
                    Push_tag('PL');
                    if Can_get_between(State.Stack[State.Top],Block.Number[I].Decoration,B) then begin
                        Pop_tag;
                        Accumulate_tag(Tag_PL,Prep);
                        Consider(Prep,B);
                        Empty_bag(Prep);
                        end
                      else
                        Pop_tag;
                    end;
            procedure Consider_interpolating;
                begin
                    end;
            procedure Consider_popping_things;
                begin
                    repeat
                        Accumulate_anti_tag(Pop_tag,Prep);
                        if Can_get_between(State.Stack[State.Top],Block.Number[I].Decoration,B) then
                            Consider(Prep,B);
                      until (State.Top = 0) or (Opt.Count = Max_opt_count);
                    Apply_tags(Reverse_bag(Prep));
                    end;
            procedure Find_best_option;
                var
                    J : integer;
                begin
                    Best_option := 1;
                    Best_cost   := Cost_of_bag(Opt.Number[Best_option]);
                    for J := 2 to Opt.Count do
                        if Cost_of_bag(Opt.Number[J]) < Best_cost then begin
                            Best_option := J;
                            Best_cost   := Cost_of_bag(Opt.Number[Best_option]);
                            end;
                    end;
            procedure Sort_for_future(Node,Best_option : integer);
                var
                    B1,B2,BX,BBest : A_bag_of_tags;
                    T     : A_tag;
                    A     : boolean;
                    I     : integer;
                begin
                    if Node < Block.Count then with Block.Number[Node+1] do
                        if Can_get_between(State.Stack[State.Top],Decoration,BX) then begin
                            Empty_bag(B1);
                            Empty_bag(B2);
                            BBest := Opt.Number[Best_option];
                            I := 1;
                            while Item_from_bag(BBest,I,T,A) do begin
                                if A then
                                    Accumulate_anti_tag(T,B1)
                                  else if Bag_contains(T,BX) then
                                    Accumulate_tag(T,B1)
                                  else
                                    Accumulate_tag(T,B2);
                                inc(I);
                                end;
                           Opt.Number[Best_option] := B1+B2;
                           end;
                    end;
            begin
                Clear_state;
                Prior := 0;
                for I := 1 to Block.Count do with Block.Number[I] do begin
                    Opt.Count := 0;
                    Consider_just_adding;
                    Consider_PL;
                    Consider_interpolating;
                    Consider_popping_things;
                    Find_best_option;
                    Sort_for_future(I,Best_option);
                    Apply_tags(Opt.Number[Best_option]);
                    Prior := Add_option(I,Prior);
                    Clear_tag_block(Blk);
                    Blk.Tags := Opt.Number[Best_option];
                    Blk.Cost := Cost_of_bag(Blk.Tags);
                    Blk.Result_state := State.Stack[State.Top];
                    Add_step(Options[Prior],Blk);
                    end;
                end;
        procedure Pick_best_option;
            var
                I,J : integer;
            begin
                with Block.Number[Block.Count] do begin
                    Best := 0;
                    for I := 1 to length(Options)-1 do
                        if Options[I].Cost < Options[Best].Cost then
                            Best := I;
                    end;
                J := Block.Number[Block.Count].Best;
                for I := Block.Count-1 downto 0 do begin
                    Block.Number[I].Best := Block.Number[I+1].Options[J].Prior;
                    J := Block.Number[I].Best;
                    end;
                end;
        procedure Emit_results;
            procedure Push_tag(Tag : string);
                begin
                    with State do begin
                        inc(Top);
                        Stack[Top] := Stack[Top-1];
                        Tags[Top]  := Tag_starting[Tag[1]];
                        Mod_flags(Stack[Top],Tag[1]);
                        end;
                    end;
            procedure Pop_tag;
                begin
                    with State do
                        if Top > 0 then begin
                            write('</',Text_of_tag[Tags[Top]],'>');
                            dec(Top);
                            end;
                    end;
            procedure Emit_tag(Tag : string);
                begin
                    Push_tag(Tag);
                    write('<',Tag,'>');
                    end;
            procedure Emit_tags(B : A_bag_of_tags);
                var
                    T : A_tag;
                    A : boolean;
                    I : integer;
                begin
                    I := 1;
                    while Item_from_bag(B,I,T,A) do begin
                        if A then
                            Pop_tag
                          else
                            Emit_tag(Text_of_tag[T]);
                        inc(I);
                        end;
                    end;
            var
                I,J   : integer;
            begin
                Clear_state;
                for I := 1 to Block.Count do begin
                    with Block.Number[I],Options[Best] do begin
                        for J := 0 to length(Steps)-1 do
                            Emit_tags(Steps[J].Tags);
                        with State,Stack[Top] do
                            if F+M+Decoration.M <> Decoration.F+M+Decoration.M then
                                writeln(ErrOutput,'Bug!');
                        write(Body);
                        end;
                    end;
                while State.Top > 0 do Pop_tag;
                if Block.Count > 0 then close(Output);
                end;
    var
        Start : TDateTime;
    begin
        Start := Time;
        Read_and_interpret_source;
        Generate_options;
        Pick_best_option;
        Emit_results;
        //writeln(ErrOutput,(Time-Start)*24*60*60:6:3);
        end.


